<%= File.read(File.join File.dirname(__FILE__), 'header.html.erb') %>

<% if @user %>

<div id="player-logout">
  <p><%= @user.email %> <a href="/overview/logout">logout</a></p>
</div>

<div class="stats-container">
  <div class="table-div">
    <h5 id="stats">Stats</h5>
    <table id="" class="table stable-inverse">
      <thead>
        <tr class="header">
          <td>Resource</td>
          <td>Count</td>
          <td></td>
        </tr>
      </thead>
      <tbody>
        <% %w(metal fiber petrol).each do |resource| %>
        <tr>
          <td><%= resource %> </td>
          <td id="<%= resource %>-count"><%= @user.send(resource) %></td>
          <td></td>
        </tr>
        <% end %>
        <tr class="header">
          <td>Resource</td>
          <td>Count</td>
          <td>Build in progress</td>
        </tr>
        <% %w(trailers factories hubs warehouses).each do |resource| %>
        <tr>
          <td><%= resource %> </td>
          <td id="<%= resource %>-count"><%= @user.send(resource).where(build_in_progress: false).count %></td>
          <td id="<%= resource %>-building-count"><%=  @user.send(resource).where(build_in_progress: true).count %></td>
        </tr>
        <% end %>
      </tbody>
    </table>
  </div>
</div>

<div class="buttons-div">
  <button class="btn btn-sm btn-outline-secondary btn-small" onclick="buildTrailers();">Build 10 trailer trucks</button>
  <a href="/overview/marketplace" class="btn btn-sm btn-outline-secondary btn-small">Go to marketplace</a>
  <button class="btn btn-sm btn-outline-secondary btn-small" onclick="createResource('trailers')">+ Trailer</button>
  <button class="btn btn-sm btn-outline-secondary btn-small" onclick="createResource('factories')">+ Factory</button>
  <button class="btn btn-sm btn-outline-secondary btn-small" onclick="createResource('hubs')">+ Hub</button>
  <button class="btn btn-sm btn-outline-secondary btn-small" onclick="createResource('warehouses')">+ Warehouse</button>
</div>

<% %w(trailers factories hubs warehouses).each do |resource| %>
<div class="table-div">
  <!-- <button onlcick="showTable(<%=resource%>,this);"></button> -->
  <button class="btn resource-btn" onclick="showTable('<%= resource %>', this)">&#9650; <%= resource.capitalize %></button>

  <table id="<%= resource %>-table-header" class="table stable-inverse d-none">
    <thead>
      <tr>
        <td>ID</td>
        <% unless resource == 'trailers'%>
          <td>Level</td>
        <% end %>
        <td>Building</td>
        <td>Actions</td>
      </tr>
    </thead>
  </table>
<div class="scrollable">
  <table id="<%= resource %>-table" class="table stable-inverse d-none">
    <tbody>
      <% @user.send(resource).each do |r| %>
      <tr id="<%= r.id %>">
        <td><%= r.id %></td>
        <% unless resource == 'trailers'%>
          <td><%= r.level %></td>
        <% end %>
        <td><%= r.build_in_progress %></td>
        <td>
          <% unless resource == 'trailers'%>
          <button class="btn btn-sm btn-outline-secondary btn-small"
                  data-id="<%= r.id %>"
                  data-resource="<%= resource %>"
                  onclick="levelUp(this);">+1 level</button>
          <% end %>
          <% if r.for_sale %>
            <button class="btn btn-sm btn-outline-secondary btn-small"
                    data-id="<%= r.id %>"
                    data-resource="<%= resource %>"
                    onclick="removeAd(this);">remove ad</button>
          <% else %>
            <button class="btn btn-sm btn-outline-secondary btn-small"
                    data-id="<%= r.id %>"
                    data-resource="<%= resource %>"
                    onclick="enableModal(this);"
                    data-toggle="modal" data-target="#sell-modal">advertise</button>
          <% end %>

          <button class="btn btn-sm btn-outline-secondary btn-small"
                  data-id="<%= r.id %>"
                  data-resource="<%= resource %>"
                  onclick="deleteResource(this);">delete</button>
        </td>
      </tr>
      <% end %>
    </tbody>
  </table>
</div>
</div>

<div class="modal fade" id="sell-modal" role="dialog">
    <div class="modal-dialog info-edit-dialog" >

      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <form id="captureForm">
          <div class="modal-body">
            <input type="hidden" name="" id="sale_id" value="">
            <input type="hidden" name="" id="sale_resource" value="">

            <div class="form-group">
              <label for="sale_metal">Metal</label>
              <input type="number" name="quantity" min="0" class="form-control" id="sale_metal" value="0">
            </div>

            <div class="form-group">
              <label for="sale_fiber">Fiber</label>
              <input type="number" name="quantity" min="0" class="form-control" id="sale_fiber" value="0">
            </div>

            <div class="form-group">
              <label for="sale_petrol">Petrol</label>
              <input type="number" name="quantity" min="0" class="form-control" id="sale_petrol" value="0">
            </div>

          </div>
          <!-- end drm params -->
          <div class="modal-footer">
            <p id="feedback" style="display:none;">An error has occurred.</p>
            <br>
            <button class="btn btn-outline-secondary btn-sm" id="submit-btn-modal" onclick="event.preventDefault(); advertiseResource();">Advertise</button>
            <button type="button" class="btn btn-outline-secondary btn-sm" id="capture-cancel-btn" data-dismiss="modal">Cancel</button>
          </div>
        </form>
      </div>

    </div>
  </div>
<% end %>

</div>  <!-- /container -->

<style media="screen">
.content *{
  font-size: 0.97em;
}
.content {
  padding: 20px 20px 20px 20px;
}
.table-div {
  border: 1px solid rgba(0,0,0,.1);
  padding: 5px 5px 5px 5px;
  margin: 5px 5px 5px 5px;
}
.scrollable {
  overflow-y: scroll;
  max-height: 230px;
}
.resource-btn {
  width: 150px;
  text-align: left;
  padding: 0px 0px 0px 5px;
  margin: 0;
  color: grey;
  background-color: transparent;
}

td {
  width: 10% !important;
}

thead > tr > td {
  font-weight: bold;
  border-top: 0px solid rgba(0,0,0,.0) !important;
}

tbody > tr > td {
  padding: 5px 5px 5px 12px !important;
}

thead > tr {
  border-top: 0px solid rgba(0,0,0,.0) !important;
}
#trailers-table-header, #warehouses-table-header, #hubs-table-header, #factories-table-header{
  border-top: 1px solid rgba(0,0,0,.0) !important;
  border-bottom: 1px solid rgba(0,0,0,.5) !important;
  margin-bottom: 0;
}

#stats {
  margin: 10px 10px 10px 10px;
  color: grey;
}
#player-logout {
  margin: 10px 10px 10px 10px;
  color: grey;
}
.header {
  border-top: 1px solid rgba(0,0,0,.0) !important;
  border-bottom: 1px solid rgba(0,0,0,.5) !important;
  font-weight: bold;
}
.buttons-div {
  padding: 10px 5px 10px 5px;
}
</style>

<script>
  function buildTrailers() {
    $.ajax({
      type: 'POST',
      url: '../../trailers/automated_build',
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      data: JSON.stringify({count: 10}),
      success: function() { alert('Trailers enqueued'); },
      error: function(data) {
        alert(data.responseJSON.error);
      }
    });
  }

  function showTable(resource, el) {
    var table = document.getElementById(resource + '-table')
    var header = document.getElementById(resource + '-table-header')
    if (table.classList.contains('d-none')) {
      table.classList.remove('d-none');
      header.classList.remove('d-none');
      el.innerHTML = '&#9660; ' + resource[0].toUpperCase() + resource.slice(1);
    } else {
      table.classList.add('d-none');
      header.classList.add('d-none');
      el.innerHTML = '&#9650; ' + resource[0].toUpperCase() + resource.slice(1);
    }
  }

  function updateStatsSuccess(data) {
    document.getElementById('metal-count').innerHTML = data.metal;
    document.getElementById('fiber-count').innerHTML = data.fiber;
    document.getElementById('petrol-count').innerHTML = data.petrol;

    var resources = ['trailers', 'factories', 'hubs', 'warehouses'];
    resources.forEach(function(resource) {
      var builtCount = 0;
      var buildingCount = 0;
      data[resource].forEach(function(item) {
        if (item.build_in_progress) {
          buildingCount += 1;
        } else {
          builtCount += 1;
        }
      });
      document.getElementById(resource + '-building-count').innerHTML = buildingCount;
      document.getElementById(resource + '-count').innerHTML = builtCount;
    });
  }

  function createResource(resource) {
    $.ajax({
      type: 'POST',
      url: '../../'+resource,
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      data: JSON.stringify({}),
      success: function() {
        location.reload();
      },
      error: function(data) {
        var message = ''
        for (var err in data.responseJSON.errors) {
          message += err +': '+data.responseJSON.errors[err][0]+'\n'
        }
        alert(message);
      }
    });
  }

  function removeAd(el) {
    var id = el.dataset.id;
    var resource = el.dataset.resource;
    $.ajax({
      type: 'PUT',
      url: '../../'+resource+'/'+id+'/sell',
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      data: JSON.stringify({cancel_sell: true}),
      success: function() {
        location.reload();
      },
      error: function(data) {
        var message = ''
        for (var err in data.responseJSON.errors) {
          message += err +': '+data.responseJSON.errors[err][0]+'\n'
        }
        alert(message);
      }
    });
  }

  function advertiseResource() {
    var id = document.getElementById('sale_id').value;
    var resource = document.getElementById('sale_resource').value;
    var sale_metal = document.getElementById('sale_metal').value;
    var sale_fiber = document.getElementById('sale_fiber').value;
    var sale_petrol = document.getElementById('sale_petrol').value;
    $.ajax({
      type: 'PUT',
      url: '../../'+resource+'/'+id+'/sell',
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      data: JSON.stringify({metal: sale_metal, fiber: sale_fiber, petrol: sale_petrol}),
      success: function() {
        location.reload();
      },
      error: function(data) {
        var message = ''
        for (var err in data.responseJSON.errors) {
          message += err +': '+data.responseJSON.errors[err][0]+'\n'
        }
        alert(message);
      }
    });
  }

  function enableModal(el) {
    document.getElementById('sale_id').value = el.dataset.id;
    document.getElementById('sale_resource').value = el.dataset.resource;
  }

  function levelUp(el) {
    var id = el.dataset.id;
    var resource = el.dataset.resource;
    $.ajax({
      type: 'PUT',
      url: '../../'+resource+'/'+id+'/level_up',
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      success: function() { location.reload(); },
      error: function(data) {
        var message = ''
        for (var err in data.responseJSON.errors) {
          message += err +': '+data.responseJSON.errors[err][0]+'\n'
        }
        alert(message);
      }
    });
  }

  function deleteResource(el) {
    var id = el.dataset.id;
    var resource = el.dataset.resource;
    $.ajax({
      type: 'DELETE',
      url: '../../'+resource+'/'+id,
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      success: function() { location.reload(); }
    });
  }

  function updateStats() {
    $.ajax({
      type: 'GET',
      url: '../../current_user',
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      success: updateStatsSuccess
    });
  }

  function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
  }

  window.onload = function() {
    setInterval(function(){ updateStats(); }, 5000);
  }
</script>

<% else %>
 <script type="text/javascript">
   window.onload = function() {
     window.location.href = "/overview/login";
   }
 </script>
<% end %>

<%= File.read(File.join File.dirname(__FILE__), 'footer.html.erb') %>
